3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|
*' --va'*)
26 BASE
=test-results
/$
(basename "$0" .sh
)
27 (GIT_TEST_TEE_STARTED
=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $?
> $BASE.
exit) |
tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
55 GIT_AUTHOR_EMAIL
=author@example.com
56 GIT_AUTHOR_NAME
='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL
=committer@example.com
59 GIT_COMMITTER_NAME
='C O Mitter'
63 unset GIT_EXTERNAL_DIFF
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
78 GIT_TEST_CMP
=${GIT_TEST_CMP:-diff -u}
80 # Protect ourselves from common misconfiguration to export
81 # CDPATH into the environment
86 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
88 echo "* warning: Some tests will not work if GIT_TRACE" \
89 "is set as to trace on STDERR ! *"
90 echo "* warning: Please set GIT_TRACE to something" \
91 "other than 1, 2 or true ! *"
97 # A regexp to match 5 and 40 hexdigits
98 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
99 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
101 # Each test should start with something like this, after copyright notices:
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108 TERM
=$ORIGINAL_TERM &&
111 tput bold
>/dev
/null
2>&1 &&
112 tput setaf
1 >/dev
/null
2>&1 &&
113 tput sgr0
>/dev
/null
2>&1
117 while test "$#" -ne 0
120 -d|
--d|
--de|
--deb|
--debu|
--debug)
122 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
123 immediate
=t
; shift ;;
124 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
125 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
126 -h|
--h|
--he|
--hel|
--help)
128 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
130 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
133 with_dashes
=t
; shift ;;
139 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
140 valgrind
=t
; verbose
=t
; shift ;;
142 shift ;; # was handled already
144 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
147 echo "error: unknown test option '$1'" >&2; exit 1 ;;
151 if test -n "$color"; then
157 error
) tput bold
; tput setaf
1;; # bold red
158 skip
) tput bold
; tput setaf
2;; # bold green
159 pass
) tput setaf
2;; # green
160 info
) tput setaf
3;; # brown
161 *) test -n "$quiet" && return;;
171 test -z "$1" && test -n "$quiet" && return
178 say_color error
"error: $*"
187 test "${test_description}" != "" ||
188 error
"Test script did not set test_description."
190 if test "$help" = "t"
192 echo "$test_description"
197 if test "$verbose" = "t"
201 exec 4>/dev
/null
3>/dev
/null
212 if test -n "$GIT_EXIT_OK"
216 echo >&5 "FATAL: Unexpected exit with code $code"
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
236 EDITOR
='"$FAKE_EDITOR"'
240 test_decode_color
() {
241 sed -e 's/.\[1m/<WHITE>/g' \
242 -e 's/.\[31m/<RED>/g' \
243 -e 's/.\[32m/<GREEN>/g' \
244 -e 's/.\[33m/<YELLOW>/g' \
245 -e 's/.\[34m/<BLUE>/g' \
246 -e 's/.\[35m/<MAGENTA>/g' \
247 -e 's/.\[36m/<CYAN>/g' \
248 -e 's/.\[m/<RESET>/g'
260 sed -e 's/$/Q/' |
tr Q
'\015'
264 tr '\015' Q |
sed -e 's/Q$//'
268 if test -z "${test_tick+set}"
272 test_tick
=$
(($test_tick + 60))
274 GIT_COMMITTER_DATE
="$test_tick -0700"
275 GIT_AUTHOR_DATE
="$test_tick -0700"
276 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
279 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
281 # This will commit a file with the given contents and the given commit
282 # message. It will also add a tag with <message> as name.
284 # Both <file> and <contents> default to <message>.
288 echo "${3-$1}" > "$file" &&
291 git commit
-m "$1" &&
295 # Call test_merge with the arguments "<message> <commit>", where <commit>
296 # can be a tag pointing to the commit-to-merge.
300 git merge
-m "$1" "$2" &&
304 # This function helps systems where core.filemode=false is set.
305 # Use it instead of plain 'chmod +x' to set or unset the executable bit
306 # of a file in the working directory and add it to the index.
310 git update-index
--add "--chmod=$@"
313 # Use test_set_prereq to tell that a particular prerequisite is available.
314 # The prerequisite can later be checked for in two ways:
316 # - Explicitly using test_have_prereq.
318 # - Implicitly by specifying the prerequisite tag in the calls to
319 # test_expect_{success,failure,code}.
321 # The single parameter is the prerequisite tag (a simple word, in all
322 # capital letters by convention).
325 satisfied
="$satisfied$1 "
329 test_have_prereq
() {
338 # You are not expected to call test_ok_ and test_failure_ directly, use
339 # the text_expect_* functions instead.
342 test_success
=$
(($test_success + 1))
343 say_color
"" " ok $test_count: $@"
347 test_failure
=$
(($test_failure + 1))
348 say_color error
"FAIL $test_count: $1"
350 echo "$@" |
sed -e 's/^/ /'
351 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
354 test_known_broken_ok_
() {
355 test_fixed
=$
(($test_fixed+1))
356 say_color
"" " FIXED $test_count: $@"
359 test_known_broken_failure_
() {
360 test_broken
=$
(($test_broken+1))
361 say_color skip
" still broken $test_count: $@"
365 test "$debug" = "" ||
eval "$1"
372 eval >&3 2>&4 "$test_cleanup"
377 test_count
=$
(($test_count+1))
379 for skp
in $GIT_SKIP_TESTS
381 case $this_test.
$test_count in
386 if test -z "$to_skip" && test -n "$prereq" &&
387 ! test_have_prereq
"$prereq"
393 say_color skip
>&3 "skipping test: $@"
394 say_color skip
"skip $test_count: $1"
403 test_expect_failure
() {
404 test "$#" = 3 && { prereq
=$1; shift; } || prereq
=
406 error
"bug in the test script: not 2 or 3 parameters to test-expect-failure"
409 say
>&3 "checking known breakage: $2"
411 if [ "$?" = 0 -a "$eval_ret" = 0 ]
413 test_known_broken_ok_
"$1"
415 test_known_broken_failure_
"$1"
421 test_expect_success
() {
422 test "$#" = 3 && { prereq
=$1; shift; } || prereq
=
424 error
"bug in the test script: not 2 or 3 parameters to test-expect-success"
427 say
>&3 "expecting success: $2"
429 if [ "$?" = 0 -a "$eval_ret" = 0 ]
439 test_expect_code
() {
440 test "$#" = 4 && { prereq
=$1; shift; } || prereq
=
442 error
"bug in the test script: not 3 or 4 parameters to test-expect-code"
445 say
>&3 "expecting exit code $1: $3"
447 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
457 # test_external runs external test scripts that provide continuous
458 # test output about their progress, and succeeds/fails on
459 # zero/non-zero exit code. It outputs the test output on stdout even
460 # in non-verbose mode, and announces the external script with "* run
461 # <n>: ..." before running it. When providing relative paths, keep in
462 # mind that all scripts run in "trash directory".
463 # Usage: test_external description command arguments...
464 # Example: test_external 'Perl API' perl ../path/to/test.pl
466 test "$#" = 4 && { prereq
=$1; shift; } || prereq
=
468 error
>&5 "bug in the test script: not 3 or 4 parameters to test_external"
471 if ! test_skip
"$descr" "$@"
473 # Announce the script to reduce confusion about the
474 # test output that follows.
475 say_color
"" " run $test_count: $descr ($*)"
476 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
477 # to be able to use them in script
478 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
479 # Run command; redirect its stderr to &4 as in
480 # test_run_, but keep its stdout on our stdout even in
487 test_failure_
"$descr" "$@"
492 # Like test_external, but in addition tests that the command generated
493 # no output on stderr.
494 test_external_without_stderr
() {
495 # The temporary file has no (and must have no) security
497 tmp
="$TMPDIR"; if [ -z "$tmp" ]; then tmp
=/tmp
; fi
498 stderr
="$tmp/git-external-stderr.$$.tmp"
499 test_external
"$@" 4> "$stderr"
500 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
501 descr
="no stderr: $1"
503 say
>&3 "expecting no stderr from previous command"
504 if [ ! -s "$stderr" ]; then
508 if [ "$verbose" = t
]; then
509 output
=`echo; echo Stderr is:; cat "$stderr"`
513 # rm first in case test_failure exits.
515 test_failure_
"$descr" "$@" "$output"
519 # This is not among top-level (test_expect_success | test_expect_failure)
520 # but is a prefix that can be used in the test script, like:
522 # test_expect_success 'complain and die' '
524 # do something else &&
525 # test_must_fail git checkout ../outerspace
528 # Writing this as "! git checkout ../outerspace" is wrong, because
529 # the failure could be due to a segv. We want a controlled failure.
533 test $?
-gt 0 -a $?
-le 129 -o $?
-gt 192
536 # Similar to test_must_fail, but tolerates success, too. This is
537 # meant to be used in contexts like:
539 # test_expect_success 'some command works without configuration' '
540 # test_might_fail git config --unset all.configuration &&
544 # Writing "git config --unset all.configuration || :" would be wrong,
545 # because we want to notice if it fails due to segv.
549 test $?
-ge 0 -a $?
-le 129 -o $?
-gt 192
552 # test_cmp is a helper function to compare actual and expected output.
553 # You can use it like:
555 # test_expect_success 'foo works' '
556 # echo expected >expected &&
558 # test_cmp expected actual
561 # This could be written as either "cmp" or "diff -u", but:
562 # - cmp's output is not nearly as easy to read as diff -u
563 # - not all diff versions understand "-u"
569 # This function can be used to schedule some commands to be run
570 # unconditionally at the end of the test to restore sanity:
572 # test_expect_success 'test core.capslock' '
573 # git config core.capslock true &&
574 # test_when_finished "git config --unset core.capslock" &&
578 # That would be roughly equivalent to
580 # test_expect_success 'test core.capslock' '
581 # git config core.capslock true &&
583 # git config --unset core.capslock
586 # except that the greeting and config --unset must both succeed for
589 test_when_finished
() {
591 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
594 # Most tests can use the created repository, but some may need to create more.
595 # Usage: test_create_repo <directory>
596 test_create_repo
() {
598 error
"bug in the test script: not 1 parameter to test-create-repo"
602 cd "$repo" || error
"Cannot setup test environment"
603 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
604 error
"cannot run git init -- have you built things yet?"
605 mv .git
/hooks .git
/hooks-disabled
611 test_results_dir
="$TEST_DIRECTORY/test-results"
612 mkdir
-p "$test_results_dir"
613 test_results_path
="$test_results_dir/${0%.sh}-$$"
615 echo "total $test_count" >> $test_results_path
616 echo "success $test_success" >> $test_results_path
617 echo "fixed $test_fixed" >> $test_results_path
618 echo "broken $test_broken" >> $test_results_path
619 echo "failed $test_failure" >> $test_results_path
620 echo "" >> $test_results_path
622 if test "$test_fixed" != 0
624 say_color pass
"fixed $test_fixed known breakage(s)"
626 if test "$test_broken" != 0
628 say_color error
"still have $test_broken known breakage(s)"
629 msg
="remaining $(($test_count-$test_broken)) test(s)"
631 msg
="$test_count test(s)"
633 case "$test_failure" in
635 say_color pass
"passed all $msg"
637 test -d "$remove_trash" &&
638 cd "$(dirname "$remove_trash")" &&
639 rm -rf "$(basename "$remove_trash")"
644 say_color error
"failed $test_failure among $msg"
650 # Test the binaries we have just built. The tests are kept in
651 # t/ subdirectory and are run in 'trash directory' subdirectory.
652 TEST_DIRECTORY
=$
(pwd)
653 if test -n "$valgrind"
657 test "$1" = "$(readlink "$2")" ||
{
665 while test -d "$2".lock
667 say
"Waiting for lock on $2."
674 make_valgrind_symlink
() {
675 # handle only executables
676 test -x "$1" ||
return
678 base
=$
(basename "$1")
679 symlink_target
=$TEST_DIRECTORY/..
/$base
680 # do not override scripts
681 if test -x "$symlink_target" &&
682 test ! -d "$symlink_target" &&
683 test "#!" != "$(head -c 2 < "$symlink_target")"
685 symlink_target
=..
/valgrind.sh
689 symlink_target
=..
/unprocessed-script
691 # create the link, or replace it if it is out of date
692 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
695 # override all git executables in TEST_DIRECTORY/..
696 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
697 mkdir
-p "$GIT_VALGRIND"/bin
698 for file in $TEST_DIRECTORY/..
/git
* $TEST_DIRECTORY/..
/test-
*
700 make_valgrind_symlink
$file
706 ls "$path"/git-
* 2> /dev
/null |
709 make_valgrind_symlink
"$file"
713 PATH
=$GIT_VALGRIND/bin
:$PATH
714 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
716 elif test -n "$GIT_TEST_INSTALLED" ; then
717 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
718 error
"Cannot run git from $GIT_TEST_INSTALLED."
719 PATH
=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..
:$PATH
720 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
721 else # normal case, use ../bin-wrappers only unless $with_dashes:
722 git_bin_dir
="$TEST_DIRECTORY/../bin-wrappers"
723 if ! test -x "$git_bin_dir/git" ; then
724 if test -z "$with_dashes" ; then
725 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
729 PATH
="$git_bin_dir:$PATH"
730 GIT_EXEC_PATH
=$TEST_DIRECTORY/..
731 if test -n "$with_dashes" ; then
732 PATH
="$TEST_DIRECTORY/..:$PATH"
735 GIT_TEMPLATE_DIR
=$
(pwd)/..
/templates
/blt
737 GIT_CONFIG_NOSYSTEM
=1
738 GIT_CONFIG_NOGLOBAL
=1
739 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
741 . ..
/GIT-BUILD-OPTIONS
743 GITPERLLIB
=$
(pwd)/..
/perl
/blib
/lib
:$
(pwd)/..
/perl
/blib
/arch
/auto
/Git
745 test -d ..
/templates
/blt ||
{
746 error
"You haven't built things yet, have you?"
749 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
751 GITPYTHONLIB
="$(pwd)/../git_remote_helpers/build/lib"
753 test -d ..
/git_remote_helpers
/build ||
{
754 error
"You haven't built git_remote_helpers yet, have you?"
758 if ! test -x ..
/test-chmtime
; then
759 echo >&2 'You need to build test-chmtime:'
760 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
765 test="trash directory.$(basename "$0" .sh)"
766 test -n "$root" && test="$root/$test"
768 /*) TRASH_DIRECTORY
="$test" ;;
769 *) TRASH_DIRECTORY
="$TEST_DIRECTORY/$test" ;;
771 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
774 echo >&5 "FATAL: Cannot prepare test area"
778 test_create_repo
"$test"
779 # Use -P to resolve symlinks in our working directory so that the cwd
780 # in subprocesses like git equals our $PWD (for pathname comparisons).
781 cd -P "$test" ||
exit 1
784 this_test
=${this_test%%-*}
785 for skp
in $GIT_SKIP_TESTS
788 for skp
in $GIT_SKIP_TESTS
797 say_color skip
>&3 "skipping test $this_test altogether"
798 say_color skip
"skip all tests in $this_test"
803 # Provide an implementation of the 'yes' utility
818 # Fix some commands on Windows
821 # Windows has its own (incompatible) sort and find
831 # git sees Windows-style pwd
835 # no POSIX permissions
836 # backslashes in pathspec are converted to '/'
837 # exec does not inherit the PID
840 test_set_prereq POSIXPERM
841 test_set_prereq BSLASHPSPEC
842 test_set_prereq EXECKEEPSPID
846 test -z "$NO_PERL" && test_set_prereq PERL
847 test -z "$NO_PYTHON" && test_set_prereq PYTHON
849 # test whether the filesystem supports symbolic links
850 ln -s x y
2>/dev
/null
&& test -h y
2>/dev
/null
&& test_set_prereq SYMLINKS